package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _mipanel = null;
public it.csinet.xnObjects.xnGrid _cgrid = null;
public anywheresoftware.b4a.objects.ButtonWrapper _bt1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 25;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(16777216);
 BA.debugLineNum = 26;BA.debugLine="If FirstTime=True Then";
Debug.ShouldStop(33554432);
if (_firsttime==anywheresoftware.b4a.keywords.Common.True) { 
 BA.debugLineNum = 27;BA.debugLine="Configura_Pantalla";
Debug.ShouldStop(67108864);
_configura_pantalla();
 BA.debugLineNum = 28;BA.debugLine="Carga_Datos";
Debug.ShouldStop(134217728);
_carga_datos();
 };
 BA.debugLineNum = 31;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 37;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(16);
 BA.debugLineNum = 39;BA.debugLine="End Sub";
Debug.ShouldStop(64);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 33;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(1);
 BA.debugLineNum = 35;BA.debugLine="End Sub";
Debug.ShouldStop(4);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _carga_datos() throws Exception{
		Debug.PushSubsStack("Carga_Datos (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
 BA.debugLineNum = 91;BA.debugLine="Sub Carga_Datos";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 92;BA.debugLine="For i=0 To 300";
Debug.ShouldStop(134217728);
{
final double step52 = 1;
final double limit52 = (int)(300);
for (_i = (int)(0); (step52 > 0 && _i <= limit52) || (step52 < 0 && _i >= limit52); _i += step52) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 93;BA.debugLine="Cgrid.RowAppend  ( Array As String (\"Co1 \" & i,\"Co2 \" & i, \"Co3 \" & i  ,\"Co4 \" &  i, \"\" ) )";
Debug.ShouldStop(268435456);
mostCurrent._cgrid.RowAppend(new String[]{"Co1 "+BA.NumberToString(_i),"Co2 "+BA.NumberToString(_i),"Co3 "+BA.NumberToString(_i),"Co4 "+BA.NumberToString(_i),""});
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 96;BA.debugLine="End Sub";
Debug.ShouldStop(-2147483648);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _configura_pantalla() throws Exception{
		Debug.PushSubsStack("Configura_Pantalla (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
it.csinet.xnObjects.xnGridCol[] _cc = null;
 BA.debugLineNum = 41;BA.debugLine="Sub Configura_Pantalla";
Debug.ShouldStop(256);
 BA.debugLineNum = 42;BA.debugLine="MiPanel.Initialize(100%y)";
Debug.ShouldStop(512);
mostCurrent._mipanel.Initialize(mostCurrent.activityBA,anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 43;BA.debugLine="MiPanel.Color=Colors.LightGray";
Debug.ShouldStop(1024);
mostCurrent._mipanel.setColor(anywheresoftware.b4a.keywords.Common.Colors.LightGray);
 BA.debugLineNum = 44;BA.debugLine="Activity.AddView(MiPanel, 0, 40dip, 100%x, 100%y)";
Debug.ShouldStop(2048);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._mipanel.getObject()),(int)(0),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(40)),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA));
 BA.debugLineNum = 46;BA.debugLine="If Cgrid.IsInitialized = False Then";
Debug.ShouldStop(8192);
if (mostCurrent._cgrid.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 47;BA.debugLine="Cgrid.Initialize(\"Cgrid\")";
Debug.ShouldStop(16384);
mostCurrent._cgrid.Initialize(mostCurrent.activityBA,"Cgrid");
 BA.debugLineNum = 49;BA.debugLine="Cgrid.RowHeight = 30dip";
Debug.ShouldStop(65536);
mostCurrent._cgrid.RowHeight = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30));
 BA.debugLineNum = 50;BA.debugLine="Cgrid.HeaderColor = Colors.Gray";
Debug.ShouldStop(131072);
mostCurrent._cgrid.HeaderColor = anywheresoftware.b4a.keywords.Common.Colors.Gray;
 BA.debugLineNum = 51;BA.debugLine="Cgrid.RowEvenColor = Colors.White";
Debug.ShouldStop(262144);
mostCurrent._cgrid.RowEvenColor = anywheresoftware.b4a.keywords.Common.Colors.White;
 BA.debugLineNum = 52;BA.debugLine="Cgrid.RowOddColor = Colors.RGB(192,255,192)";
Debug.ShouldStop(524288);
mostCurrent._cgrid.RowOddColor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(192),(int)(255),(int)(192));
 BA.debugLineNum = 53;BA.debugLine="Cgrid.GridColor=Colors.Black";
Debug.ShouldStop(1048576);
mostCurrent._cgrid.GridColor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 BA.debugLineNum = 54;BA.debugLine="Cgrid.HeaderHeight = 30dip";
Debug.ShouldStop(2097152);
mostCurrent._cgrid.HeaderHeight = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30));
 BA.debugLineNum = 56;BA.debugLine="Cgrid.HeaderTextSize = 13";
Debug.ShouldStop(8388608);
mostCurrent._cgrid.HeaderTextSize = (float)(13);
 BA.debugLineNum = 57;BA.debugLine="Cgrid.RowTextSize = 12";
Debug.ShouldStop(16777216);
mostCurrent._cgrid.RowTextSize = (float)(12);
 BA.debugLineNum = 58;BA.debugLine="Cgrid.HeaderTextColor = Colors.Black";
Debug.ShouldStop(33554432);
mostCurrent._cgrid.HeaderTextColor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 BA.debugLineNum = 59;BA.debugLine="Cgrid.RowTextColor = Colors.Black";
Debug.ShouldStop(67108864);
mostCurrent._cgrid.RowTextColor = anywheresoftware.b4a.keywords.Common.Colors.Black;
 BA.debugLineNum = 61;BA.debugLine="Cgrid.SelectedOddColor = Colors.RGB(192,192,255)";
Debug.ShouldStop(268435456);
mostCurrent._cgrid.SelectedOddColor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(192),(int)(192),(int)(255));
 BA.debugLineNum = 62;BA.debugLine="Cgrid.SelectedEvenColor = Colors.RGB(192,192,255)";
Debug.ShouldStop(536870912);
mostCurrent._cgrid.SelectedEvenColor = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(192),(int)(192),(int)(255));
 BA.debugLineNum = 65;BA.debugLine="Dim cc(5) As xnGridCol";
Debug.ShouldStop(1);
_cc = new it.csinet.xnObjects.xnGridCol[(int)(5)];
{
int d0 = _cc.length;
for (int i0 = 0;i0 < d0;i0++) {
_cc[i0] = new it.csinet.xnObjects.xnGridCol();
}
}
;Debug.locals.put("cc", _cc);
 BA.debugLineNum = 67;BA.debugLine="cc(0).Initialize2 (\"Indi\" , \"Campo1\" , 0dip , Gravity.LEFT+Gravity.CENTER_VERTICAL)";
Debug.ShouldStop(4);
_cc[(int)(0)].Initialize2("Indi","Campo1",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.LEFT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 68;BA.debugLine="Cgrid.ColAppend  ( cc(0) )";
Debug.ShouldStop(8);
mostCurrent._cgrid.ColAppend(_cc[(int)(0)]);
 BA.debugLineNum = 71;BA.debugLine="cc(1).Initialize2 (\"Código\", \"Campo2\" , 45dip  , Gravity.LEFT+Gravity.CENTER_VERTICAL  )";
Debug.ShouldStop(64);
_cc[(int)(1)].Initialize2("Código","Campo2",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(45)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.LEFT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 72;BA.debugLine="Cgrid.ColAppend ( cc(1) )";
Debug.ShouldStop(128);
mostCurrent._cgrid.ColAppend(_cc[(int)(1)]);
 BA.debugLineNum = 74;BA.debugLine="cc(2).Initialize2 (\"Nombre\", \"Campo3\" , 150dip , Gravity.LEFT+Gravity.CENTER_VERTICAL  )";
Debug.ShouldStop(512);
_cc[(int)(2)].Initialize2("Nombre","Campo3",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(150)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.LEFT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 75;BA.debugLine="Cgrid.ColAppend ( cc(2) )";
Debug.ShouldStop(1024);
mostCurrent._cgrid.ColAppend(_cc[(int)(2)]);
 BA.debugLineNum = 77;BA.debugLine="cc(3).Initialize2 ( \"Visita\" , \"Campo4\" ,  100dip ,  Gravity.Left+Gravity.CENTER_VERTICAL   )";
Debug.ShouldStop(4096);
_cc[(int)(3)].Initialize2("Visita","Campo4",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.LEFT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 78;BA.debugLine="Cgrid.ColAppend ( cc(3) )";
Debug.ShouldStop(8192);
mostCurrent._cgrid.ColAppend(_cc[(int)(3)]);
 BA.debugLineNum = 80;BA.debugLine="cc(4).Initialize2 ( \"\" , \"\" ,  1dip ,  Gravity.RIGHT+Gravity.CENTER_VERTICAL   )";
Debug.ShouldStop(32768);
_cc[(int)(4)].Initialize2("","",anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1)),(int)(anywheresoftware.b4a.keywords.Common.Gravity.RIGHT+anywheresoftware.b4a.keywords.Common.Gravity.CENTER_VERTICAL));
 BA.debugLineNum = 81;BA.debugLine="Cgrid.ColAppend ( cc(4) )";
Debug.ShouldStop(65536);
mostCurrent._cgrid.ColAppend(_cc[(int)(4)]);
 BA.debugLineNum = 84;BA.debugLine="MiPanel.Panel.AddView(Cgrid,0dip,2dip,Activity.Width-6dip,50%y)";
Debug.ShouldStop(524288);
mostCurrent._mipanel.getPanel().AddView((android.view.View)(mostCurrent._cgrid.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2)),(int)(mostCurrent._activity.getWidth()-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(6))),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(50),mostCurrent.activityBA));
 BA.debugLineNum = 86;BA.debugLine="Cgrid.GridWidth = 1dip";
Debug.ShouldStop(2097152);
mostCurrent._cgrid.GridWidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1));
 BA.debugLineNum = 88;BA.debugLine="Cgrid.GridCreate2 (False )";
Debug.ShouldStop(8388608);
mostCurrent._cgrid.GridCreate2(anywheresoftware.b4a.keywords.Common.False);
 };
 BA.debugLineNum = 90;BA.debugLine="End Sub";
Debug.ShouldStop(33554432);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 45764, new int[] {4}, "7a8f0167-b89b-48a6-8606-dbea16031df4");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 19;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 20;BA.debugLine="Dim MiPanel As ScrollView";
mostCurrent._mipanel = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Dim Cgrid As xnGrid";
mostCurrent._cgrid = new it.csinet.xnObjects.xnGrid();
 //BA.debugLineNum = 22;BA.debugLine="Dim bt1 As Button";
mostCurrent._bt1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 17;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"MiPanel",_mipanel,"Cgrid",_cgrid,"bt1",_bt1};
}
}
